
struct ICO_Header {
 u16le idReserved;
 u16le idType;
 u16le idCount;
};

struct IcoDirEntry {
 u8 bWidth;
 u8 bHeight;
 u8 bColorCount;
 u8 bReserved;
 u16le wPlanes;
 u16le wBitCount;
 u32le dwBytesInRes;
 u32le dwImageOffset;
};

/* https://docs.microsoft.com/en-us/windows/win32/api/wingdi/ns-wingdi-bitmapfileheader */
struct BMP_Header {
 u16le bfType;
 u32le bfSize;
 u16le bfReserved1;
 u16le bfReserved2;
 u32le bfOffBits;
};

/* https://docs.microsoft.com/en-us/windows/win32/api/wingdi/ns-wingdi-bitmapcoreheader */
struct BitmapCoreHeader {
 u32le bcSize;
 u16le bcWidth;
 u16le bcHeight;
 u16le bcPlanes;
 u16le bcBitCount;
};

/* https://docs.microsoft.com/en-us/windows/win32/api/wingdi/ns-wingdi-bitmapinfoheader */
struct BitmapInfoHeader {
 u32le biSize;
 u32le biWidth;
 u32le biHeight;
 u16le biPlanes;
 u16le biBitCount;
 u32le biCompression;
 u32le biSizeImage;
 u32le biXPelsPerMeter;
 u32le biYPelsPerMeter;
 u32le biClrUsed;
 u32le biClrImportant;
};

/* https://docs.microsoft.com/en-us/windows/win32/api/wingdi/ns-wingdi-bitmapv4header */
struct BitmapV4Header {
 u32le bV4Size;
 u32le bV4Width;
 u32le bV4Height;
 u16le bV4Planes;
 u16le bV4BitCount;
 u32le bV4V4Compression;
 u32le bV4SizeImage;
 u32le bV4XPelsPerMeter;
 u32le bV4YPelsPerMeter;
 u32le bV4ClrUsed;
 u32le bV4ClrImportant;
 u32le bV4RedMask;
 u32le bV4GreenMask;
 u32le bV4BlueMask;
 u32le bV4AlphaMask;
 u32le bV4CSType;
 u32le bV4Endpoints[3][3];
 u32le bV4GammaRed;
 u32le bV4GammaGreen;
 u32le bV4GammaBlue;
};

/* https://docs.microsoft.com/en-us/windows/win32/api/wingdi/ns-wingdi-bitmapv5header */
struct BitmapV5Header {
 u32le bV5Size;
 u32le bV5Width;
 u32le bV5Height;
 u16le bV5Planes;
 u16le bV5BitCount;
 u32le bV5Compression;
 u32le bV5SizeImage;
 u32le bV5XPelsPerMeter;
 u32le bV5YPelsPerMeter;
 u32le bV5ClrUsed;
 u32le bV5ClrImportant;
 u32le bV5RedMask;
 u32le bV5GreenMask;
 u32le bV5BlueMask;
 u32le bV5AlphaMask;
 u32le bV5CSType;
 u32le bV5Endpoints[3][3];
 u32le bV5GammaRed;
 u32le bV5GammaGreen;
 u32le bV5GammaBlue;
 u32le bV5Intent;
 u32le bV5ProfileData;
 u32le bV5ProfileSize;
 u32le bV5Reserved;
};

/* https://doxygen.reactos.org/d6/dea/bmpdecode_8c_source.html */
struct BitmapCoreHeader2 {
 u32le bc2Size;
 u32le bc2Width;
 u32le bc2Height;
 u16le bc2Planes;
 u16le bc2BitCount;
 u32le bc2Compression;
 u32le bc2SizeImage;
 u32le bc2XRes;
 u32le bc2YRes;
 u32le bc2ClrUsed;
 u32le bc2ClrImportant;
 u16le bc2ResUnit;
 u16le bc2Reserved;
 u16le bc2Orientation;
 u16le bc2Halftoning;
 u32le bc2HalftoneSize1;
 u32le bc2HalftoneSize2;
 u32le bc2ColorSpace;
 u32le bc2AppData;
};
